﻿Type=Service
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim magn As PhoneSensors
	Dim SensorsMap As Map
	Type SensorData (Name As String, ThreeValues As Boolean)
	
	Dim EvCnt As Int
	Dim LastEvCnt As Int
	Dim EvTmr As Timer
End Sub
Sub Service_Create
	magn.Initialize(magn.TYPE_MAGNETIC_FIELD)
	SensorsMap.Initialize
	AddSensor(magn, "MAG", True)

	EvTmr.Initialize("EvTmr", 2000)
End Sub

Sub Service_Start (StartingIntent As Intent)
	EvCnt = 0
End Sub

Sub Service_Destroy
	Stop
End Sub

Sub EvTmr_Tick
	Stop
End Sub

Sub Start
	Log ("Event count (Start): " & EvCnt)
	LastEvCnt = EvCnt
	' Here we start listening for SensorChanged events
	' By checking the return value we know if the sensor is supported.
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		Dim sd As SensorData
		ps = SensorsMap.GetKeyAt(i)
		sd = SensorsMap.GetValueAt(i)
		If ps.StartListening("Sensor") = False Then
			Log(sd.Name & " is not supported.")
		End If
	Next
	EvTmr.Enabled = True
End Sub

Sub Stop
	EvTmr.Enabled = False
	' Stop listening for events
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		ps = SensorsMap.GetKeyAt(i)
		ps.StopListening
	Next
	Log ("Event count (Stop): " & EvCnt & "   Diff: " & (EvCnt - LastEvCnt))
End Sub

Sub Sensor_SensorChanged (Values() As Float)
	EvCnt = EvCnt + 1
End Sub

Sub AddSensor(Sensor As PhoneSensors, Name As String, ThreeValues As Boolean)
	Dim sd As SensorData
	sd.Initialize
	sd.Name = Name
	sd.ThreeValues = ThreeValues
	SensorsMap.Put(Sensor, sd)
End Sub
